/******************************************************************************
*******************************************************************************
**                                                                           **
**      MOST for C Swing and Gopher - A file viewer                          **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: John E. Davis                                  **
**                                                                           **
**      Modifications primarily by Foteos Macrides                           **
**                                                                           **
**      Copyright 1991, John E. Davis                                        **
**                                                                           **
**      Terms of Copyright: See MAIN.C                                       **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
/*
 *  MOST:  most.c
 *
 *  Modified for C SWING and GOPHER compatibility by Foteos Macrides
 *                                                MACRIDES@SCI.WFEB.EDU
 */

#include <stdio.h>
#include "externs.h"
#include "window.h"
#include "buffer.h"
#include "file.h"
#include "sysdep.h"
#include "keym.h"
#include "most.h"
#include "search.h"  

void most(char *file, int start)
{
    int piped, row, col;
    char most_info_line[136];
    char MOST_START_DIR[136];
    extern char *MOST_VERSION;
    globaldef int exit_most;
    
    exit_most = 0;
    init_display();
    get_cdir(C_DIR);
    strcpy(MOST_START_DIR, C_DIR);

    row = col = 0;
    if (file[0] == '\0') piped = 1; else piped = 0;
    
    find_file(file);
    goto_line(start);
    CURS_POS = C_POS;
    if (*SEARCH_STR != '\0' && (row = search(C_POS,1,&col), row > 0))
      {
          goto_line(row);
      }
    else
      {
          row = C_LINE;
          col = 1;
      }

    window_buffer();
    CURS_ROW = WIN->curs_line = row - C_LINE + 1;
    WIN->curs_pos = CURS_POS;
    CURS_COL = WIN->curs_col = col;
    sprintf(most_info_line," MOST(%.*s)", strlen(MOST_VERSION),MOST_VERSION);
    if (!MOST_H_OPT && (!(MOST_N_OPT && getenv("MOST_PROMPT") == NULL)))
         strcat(most_info_line, "  Press ? or h for help if needed.");
    most_message(most_info_line, 0);
    redraw_window();
    update_status(1);

    while (!exit_most)
      {
          execute_key();
      } 
    exit_most = 0;
    if (strcmp(MOST_START_DIR, C_DIR))
         chdir(MOST_START_DIR);
    return;
}
